
function MessageBox(Message)
	if (Message == nil) then --No message was passed
		Message = "nil" --If no message is passed this will be the default message
	end
	
	wx.wxMessageBox(tostring(Message) )
end





 function GetRegisterAsDouble(path)
    local hReg, rc = mc.mcRegGetHandle(mc.mcGetInstance(), path)
    if (rc == mc.MERROR_NOERROR) then
        local value, rc = mc.mcRegGetValue(hReg)
        if (rc == mc.MERROR_NOERROR) then
            return value
        end
    end
    return 0
end

 function GetRegAsDouble(path)
    return GetRegisterAsDouble("iRegs0/"..path)
 end



 function GetRegisterAsLong(path)
    local hReg, rc = mc.mcRegGetHandle(mc.mcGetInstance(), path)
    if (rc == mc.MERROR_NOERROR) then
        local value, rc = mc.mcRegGetValueLong(hReg)
        if (rc == mc.MERROR_NOERROR) then
            return value
        end
    end
    return 0
end

 function GetRegAsLong(path)
    return GetRegisterAsLong("iRegs0/"..path)
 end


 function GetRegisterAsString(path)
    local hReg, rc = mc.mcRegGetHandle(mc.mcGetInstance(), path)
    if (rc == mc.MERROR_NOERROR) then
        local value, rc = mc.mcRegGetValueString(hReg)
        if (rc == mc.MERROR_NOERROR) then
            return value
        end
    end
    return 0
end

 function GetRegAsString(path)
    return GetRegisterAsString("iRegs0/"..path)
 end


 function SetRegisterAsDouble(path, value)
   local hReg, rc = mc.mcRegGetHandle(mc.mcGetInstance(), path)
    if (rc == mc.MERROR_NOERROR) then
        rc = mc.mcRegSetValue(hReg, value)
        if (rc == mc.MERROR_NOERROR) then
            return rc
        end
    end
    return
end

function SetRegAsDouble(path, value)
   return SetRegisterAsDouble("iRegs0/"..path, value)
end


 function SetRegisterAsLong(path, value)
   local hReg, rc = mc.mcRegGetHandle(mc.mcGetInstance(), path)
    if (rc == mc.MERROR_NOERROR) then
        rc = mc.mcRegSetValueLong(hReg, value)
        if (rc == mc.MERROR_NOERROR) then
            return rc
        end
    end
    return
end

function SetRegAsLong(path, value)
   return SetRegisterAsLong("iRegs0/"..path, value)
end



 function SetRegisterAsString(path, value)
   local hReg, rc = mc.mcRegGetHandle(mc.mcGetInstance(), path)
    if (rc == mc.MERROR_NOERROR) then
        rc = mc.mcRegSetValueString(hReg, value)
        if (rc == mc.MERROR_NOERROR) then
            return rc
        end
    end
    return
end

function SetRegAsString(path, value)
   return SetRegisterAsString("iRegs0/"..path, value)
end


 function GetSignal(SIG)
	
	local inst = mc.mcGetInstance()
	
	local hSig, rc = mc.mcSignalGetHandle(inst, SIG) 
	if (rc~= 0) then 
		mc.mcCntlSetLastError(inst, "mc.mcSignalGetHandle an error")
	else 
       local State, rc= mc.mcSignalGetState(hSig) 
        
        if (rc==0) then 
          return State  
        else
            mc.mcCntlSetLastError(inst, "mcSignalGetState an error")
            return nil
        end
    end 
end


 function SetSignal(SIG,Value)

	
	local inst = mc.mcGetInstance()
	
	local hSig, rc = mc.mcSignalGetHandle(inst, SIG) 
	if (rc~= 0) then 
		mc.mcCntlSetLastError(inst, "mc.mcSignalGetHandle an error")
	else 
        rc = mc.mcSignalSetState(hSig, Value) 
        if (rc~= 0) then 
            mc.mcCntlSetLastError(inst, "mcSignalSetState an error")
        end
    end 
end


function mcCntlSetLastError(_inst,str)
    print(str) 
    mc.mcCntlLog(_inst, tostring(str), "", -1 )
   return mc.mcCntlSetLastError(_inst, tostring(str))    
end






function setOutputON(number)
	local Osig = mc.OSIG_OUTPUT0
	Osig = (Osig + number)
	local hReg = mc.mcSignalGetHandle(mc.mcGetInstance(), Osig)
	if( hReg ~= nil ) then
		return mc.mcSignalSetState(hReg, true) --Turn the output on
	end
end

function ActivateSignal(Osig)
--	local Osig = mc.OSIG_OUTPUT0
--	Osig = (Osig + number)
	local hReg = mc.mcSignalGetHandle(mc.mcGetInstance(), Osig)
	if( hReg ~= nil ) then
		return mc.mcSignalSetState(hReg, true) --Turn the output on
	end
end

function setOutputOFF(number)
	local Osig = mc.OSIG_OUTPUT0
	Osig = (Osig + number)
	local hReg = mc.mcSignalGetHandle(mc.mcGetInstance(), Osig)
	if( hReg ~= nil ) then
	return mc.mcSignalSetState(hReg, false) --Turn the output off
	end
end


function DeActivateSignal(Osig)
--	local Osig = mc.OSIG_OUTPUT0
--	Osig = (Osig + number)
	local hReg = mc.mcSignalGetHandle(mc.mcGetInstance(), Osig)
	if( hReg ~= nil ) then
		return mc.mcSignalSetState(hReg, false) --Turn the output off
	end
end


function Sleep(delayMs)
	wx.wxMilliSleep(delayMs) --Sleep for the commanded time (so that the output stays on as long as we want).
end


function millis()
	
	local Value , rc=mc.mcCntlGetPoundVar(mc.mcGetInstance(), 1);
	
	return wx.wxGetLocalTimeMillis():ToDouble() - Value
end


function setOutput(number,value)
	
--	wx.wxMessageBox("")
--	mc.mcCntlSetLastError(0, string.format("setOutput" ))
	--mc.mcCntlSetLastError(0, string.format("setOutput(%d,%d)",tonumber (number),tonumber (value)  ))
	
--	MessageBox(string.format("setOutput(%d,%d)",number,value ))
	local Osig = mc.OSIG_OUTPUT0
	Osig = (Osig + number)
	local hReg = mc.mcSignalGetHandle(mc.mcGetInstance(), Osig)
	if( hReg ~= nil ) then
		return mc.mcSignalSetState(hReg, value) --Turn the output on
	end
end


function SetVar(varNum,value)
	local rc=mc.mcCntlSetPoundVar(mc.mcGetInstance(), varNum,value);
	return rc
end


function setOutput(number,value)
	
--	wx.wxMessageBox("")
--	mc.mcCntlSetLastError(0, string.format("setOutput" ))
	--mc.mcCntlSetLastError(0, string.format("setOutput(%d,%d)",tonumber (number),tonumber (value)  ))
	
--	MessageBox(string.format("setOutput(%d,%d)",number,value ))
	local Osig = mc.OSIG_OUTPUT0
	Osig = (Osig + number)
	local hReg = mc.mcSignalGetHandle(mc.mcGetInstance(), Osig)
	if( hReg ~= nil ) then
		return mc.mcSignalSetState(hReg, value) --Turn the output on
	end
end



function Code(GCode)
	return mc.mcCntlGcodeExecute(mc.mcGetInstance(),GCode)
end


function Message(str)

	mc.mcCntlSetLastError(mc.mcGetInstance(), tostring(str))

end

function GetFileExt(file)
--	local ext = file:match("^.+(%..+)$")
--	if (ext==nil) then 
--		return ""
--	else 
--		return ext
--	end

	local FileExt = wx.wxFileName(file):GetExt()
		
	return FileExt 

end

function GetFileName(file)
	local FileName = wx.wxFileName(file):GetName()
	return FileName 
end


function FileExists(file)
	return wx.wxFileExists(file)	
end


function FileDelete(file)
	return os.remove(file)
end





